unit Unit1;

{$mode objfpc}{$H+}
{$DEFINE MICHL}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MI_Panel1: TMenuItem;
    MI_Panel2: TMenuItem;
    MI_Panel3: TMenuItem;
    MI_Panel4: TMenuItem;
    MI_Panel5: TMenuItem;
    MI_Panel6: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowPanel(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{$IFDEF MICHL}
var
  PanelArray: Array[1..6] of Record
    Panel: TPanel;
    MenuItem: TMenuItem;
  end;
{$ENDIF}


procedure TForm1.ShowPanel(Sender: TObject);
var
  i: Integer;
  {$IFNDEF MICHL}
  mnuitem: TMenuItem;
  {$ENDIF}
begin
  {$IFDEF MICHL}
    for i:=1 to 6 do
      if Sender = PanelArray[i].MenuItem then begin
        PanelArray[i].Panel.Enabled := True;
        PanelArray[i].Panel.Visible := True;
        PanelArray[i].MenuItem.Checked := True;
      end else begin
        PanelArray[i].Panel.Enabled := False;
        PanelArray[i].Panel.Visible := False;
      end;
    {$ELSE}
      if (Sender is TMenuItem) then begin
        mnuitem := TMenuItem(Sender);

        if assigned(TPanel(mnuitem.Tag)) then

          for i:=0 to ComponentCount-1 do
            if (Components[i] is TMenuItem) and assigned(TPanel(Components[i].Tag)) then
              if Components[i]=mnuitem then begin
                TMenuItem(Components[i]).Checked:=True;
                TPanel(TMenuItem(Components[i]).Tag).Visible:=True;
                TPanel(TMenuItem(Components[i]).Tag).Enabled:=True;
              end else begin
                TPanel(TMenuItem(Components[i]).Tag).Visible:=False;
                TPanel(TMenuItem(Components[i]).Tag).Enabled:=False;
              end;
      end;
    {$ENDIF}
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i:Integer;
begin
  {$IFDEF MICHL}
    PanelArray[1].Panel:=Panel1;
    PanelArray[1].MenuItem:=MI_Panel1;
    PanelArray[2].Panel:=Panel2;
    PanelArray[2].MenuItem:=MI_Panel2;
    PanelArray[3].Panel:=Panel3;
    PanelArray[3].MenuItem:=MI_Panel3;
    PanelArray[4].Panel:=Panel4;
    PanelArray[4].MenuItem:=MI_Panel4;
    PanelArray[5].Panel:=Panel5;
    PanelArray[5].MenuItem:=MI_Panel5;
    PanelArray[6].Panel:=Panel6;
    PanelArray[6].MenuItem:=MI_Panel6;

    for i:=1 to 6 do begin
      PanelArray[i].Panel.Visible:=False;
      PanelArray[i].Panel.Enabled:=False;
    end;
  {$ELSE}
    MI_Panel1.Tag := PtrInt(Panel1);
    MI_Panel2.Tag := PtrInt(Panel2);
    MI_Panel3.Tag := PtrInt(Panel3);
    MI_Panel4.Tag := PtrInt(Panel4);
    MI_Panel5.Tag := PtrInt(Panel5);
    MI_Panel6.Tag := PtrInt(Panel6);

    Panel1.Visible:=False;
    Panel1.Enabled:=False;
    Panel2.Visible:=False;
    Panel2.Enabled:=False;
    Panel3.Visible:=False;
    Panel3.Enabled:=False;
    Panel4.Visible:=False;
    Panel4.Enabled:=False;
    Panel5.Visible:=False;
    Panel5.Enabled:=False;
    Panel6.Visible:=False;
    Panel6.Enabled:=False;
  {$ENDIF}
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Folgendes Panel ist aktiv:');
  {$IFDEF MICHL}
  for i:=1 to 6 do
    if PanelArray[i].Panel.Visible then
      Memo1.Lines.Add('Panel Nr['+IntToStr(i)+']: '+PanelArray[i].Panel.Name);
  {$ELSE}
    for i:=0 to ComponentCount-1 do
      if Components[i] is TPanel then
        if TPanel(Components[i]).Visible then
          memo1.Lines.Add(TPanel(Components[i]).Name);
  {$ENDIF}
end;

end.

